Attribute VB_Name = "Module1"
Option Explicit

Private Type POINTAPI
    X As Long
    Y As Long
End Type

Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function MoveWindow Lib "user32" (ByVal hwnd As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal bRepaint As Long) As Long
Private Declare Function ScreenToClient Lib "user32" (ByVal hwnd As Long, lpPoint As POINTAPI) As Long
Private Declare Function GetWindowRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long

Private Const CB_GETITEMHEIGHT      As Long = &H154

'---------------------------------------------------------------------------------
Public Sub SetDropDownHeight(pobjForm As Form, _
                             pobjCombo As ComboBox, _
                             plngNumItemsToDisplay As Long)
'---------------------------------------------------------------------------------

    Dim pt              As POINTAPI
    Dim rc              As RECT
    Dim lngSavedWidth   As Long
    Dim lngNewHeight    As Long
    Dim lngOldScaleMode As Long
    Dim lngItemHeight   As Long

    lngSavedWidth = pobjCombo.Width

    lngOldScaleMode = pobjForm.ScaleMode
    pobjForm.ScaleMode = vbPixels
    
    lngItemHeight = SendMessage(pobjCombo.hwnd, CB_GETITEMHEIGHT, 0, ByVal 0)
    
    lngNewHeight = lngItemHeight * (plngNumItemsToDisplay + 2)
    
    Call GetWindowRect(pobjCombo.hwnd, rc)
    pt.X = rc.Left
    pt.Y = rc.Top
    
    Call ScreenToClient(pobjForm.hwnd, pt)
    
    Call MoveWindow(pobjCombo.hwnd, pt.X, pt.Y, pobjCombo.Height, lngNewHeight, True)
    
    pobjForm.ScaleMode = lngOldScaleMode
    pobjCombo.Width = lngSavedWidth

End Sub

